/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package graphertemplate;

import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author Tesla
 */
public class MainWindow extends JFrame 
{
    PlotPanel plotPanel = new PlotPanel();
    public MainWindow(){
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        initContentPane();
        pack();
        setLocationRelativeTo(null);
        setVisible(true);
    }
    private void initContentPane(){
        plotPanel.lineX.setLine(0d, 400d, 800d, 400d);
        plotPanel.lineY.setLine(400d, 0d, 400d, 800d);
        getContentPane().add(plotPanel);
    }
     
    class PlotPanel extends JPanel{
        Point lineXStart = new Point(0, 0);
        Point lineXEnd = new Point(0, 0);
        Point lineYStart = new Point(0, 0);
        Point lineYEnd = new Point(0, 0);
        Line2D lineX = new Line2D.Double(lineXStart, lineXEnd);
        Line2D lineY = new Line2D.Double(lineYStart, lineYEnd);
        //Point point = new Point(x,y);
        //width of line
        private Stroke stroke = new BasicStroke(2.0f);
        private LineListener lis = null;
        PlotPanel()
        {
            super();
            addMouseListener(lis = new LineListener(this, lineX));
        }
        //draw and delete line
        @Override
        public void paintComponent(Graphics g)
        {
            super.paintComponent(g);
            setBackground(Color.white);
            Graphics2D g2 = (Graphics2D) g;
            g2.setStroke(stroke);
            if (lis.deleteLine){
                g2.setColor(getBackground());
                lis.deleteLine = false;
            }
            else
            g2.setColor(Color.black);
            //draw shape of line
            g2.draw(lineX);
            g2.draw(lineY);
        }
        @Override
        public Dimension getPreferredSize(){
            return new Dimension(800, 800);
        }
    }
    
     class LineListener extends MouseAdapter
         {
         private Line2D line = null;
         private JComponent parent = null;
         boolean deleteLine = false;
         LineListener(JComponent parent, Line2D line)
             {
             this.parent = parent;
             this.line = line;
         }
        @Override
         public void mouseClicked(MouseEvent e)
             {
             Point p = e.getPoint();
             //this does it!
             if (line.ptSegDist(p) == 0.0)
                 {
                 System.out.println("Hit!");
                 deleteLine = true;
             }
             else
             System.out.println("Point: " + p + "\nDistance: " + line.ptSegDist(p));
             parent.repaint();
         }
     }
    
}
